/*
 ******************************************************************************
 ******************************************************************************
 *****                        read_demo_obj.c                             *****
 *****									  *****
 *****		           File reading utility				  *****
 *****									  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, 1993. All Rights Reserved                             *
 *			SHOgraphics					      *
 *			321 Soquel Way           			      *
 *			Sunnyvale, CA     94086   			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the name of SHOgraphics not be
 used in advertising or publicity pertaining to distribution of the 
 software without specific, written prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ */

#if defined(SYSV) || defined(sun)
#include <string.h>
#else
#include <strings.h>
#endif

#define MAXVERTS 9000
#define MAXPOLYS 8000

	float 		global_x_min, global_x_max, global_x,
			global_y_min, global_y_max, global_y,
			global_z_min, global_z_max, global_z;

	Fcoord3D *verts, *vertn, *vertt;
	unsigned short	   *vert_indices, *vn_indices, *vt_indices;
	int	   poly_cnt, vct, vnct, vtct, numEdges;
	unsigned short *facet_Count, *norm_Count;
	float	   z_trans_factor = -5.0;
	float	   zoom_factor = 1.0;
	int	   flip_flag = 0;


read_demo_obj(fname, ctr, scale)
char *fname;
Fcoord3D *ctr;
float	scale;
{
    FILE *fp2, *fopen();
    char buffer[512],objname2[128], *ptr, *bufptr;
    char *objname;
    int v[16];
    int i, j, value, flag, lcount, itmp;
    double atof();

    lcount = numEdges = vct = vtct = vnct = poly_cnt = 0;
    global_x_max = global_y_max = global_z_max = -20000.;
    global_x_min = global_y_min = global_z_min =  20000.;
    global_x = global_y = global_z = 10.0;

    verts = (Fcoord3D *) malloc( 12 * MAXVERTS);
    vertt = (Fcoord3D *) malloc( 12 * MAXVERTS);
    vertn = (Fcoord3D *) malloc( 12 * MAXVERTS);
    vert_indices = (unsigned short *) malloc( sizeof(short) * MAXPOLYS*4);
    vn_indices = (unsigned short *) malloc( sizeof(short) * MAXPOLYS*4);
    vt_indices = (unsigned short *) malloc( sizeof(short) * MAXPOLYS*4);
    facet_Count = (unsigned short *) malloc( MAXPOLYS * sizeof(unsigned short));
    norm_Count  = (unsigned short *) malloc( MAXPOLYS * sizeof(unsigned short));

	strcpy(objname2,fname);
						/* read in file.obj */
    if((fp2 = fopen(fname, "r")) == NULL)  {
	strcat(objname2,".obj");
	
    	if((fp2 = fopen(objname2, "r")) == NULL)  {
	  printf("Error: can't open object %s\n", fname);
	  exit(-1);
	}
    }

    while(1) {

	if(fgets(buffer, 128, fp2) == NULL)
	    break;

	lcount++;
	switch(*buffer)  {
	default:
	    break;
/* #define OLD_PARSE */
#ifdef OLD_PARSE
	case 'v':
	    sscanf(buffer, "v %f %f %f\n",
		    &verts[vct].x, &verts[vct].y, &verts[vct].z);
		verts[vct].x *= scale;
		verts[vct].y *= scale;
		verts[vct].z = verts[vct].z + z_trans_factor;
		if( verts[vct].x > global_x_max)
			global_x_max = verts[vct].x;
		if( verts[vct].x < global_x_min)
			global_x_min = verts[vct].x;
		if( verts[vct].y > global_y_max)
			global_y_max = verts[vct].y;
		if( verts[vct].y < global_y_min)
			global_y_min = verts[vct].y;
		if( verts[vct].z > global_z_max)
			global_z_max = verts[vct].z;
		if( verts[vct].z < global_z_min)
			global_z_min = verts[vct].z;
	    vct++;
	    break;
	case 'f' :
	    i=0;
	    bufptr = strchr( buffer, '\n');
	    if( bufptr == NULL ) break;
	    *bufptr = 0;
	    bufptr = buffer;
	    while( *bufptr != '\0' && *bufptr != ' ') bufptr++;/* next token */
	    if( bufptr == NULL ) break;
	    bufptr=strtok( bufptr, " ");
	    while(1){
	      while( *bufptr != '\0' && *bufptr == ' ' ) bufptr++;
		if( *bufptr == '\0' ) break;
		if( is_digit(*bufptr) )
		    v[i] = atoi(bufptr);
		else {break;}
		if( v[i] == 0 ){ break;}
		if( v[i] < 0 ) v[i] = vct + v[i] + 1;
		if( v[i] > vct+1 )
		{ 
			printf("bogus file read!!\n");
			exit(-1);
	    	}
		vert_indices[numEdges++] = v[i]-1;
		i++;
		bufptr= strtok(NULL," ");
	    }
	    facet_Count[poly_cnt] = i;
	   poly_cnt++;
	  break;
#else
	case 'v':
	  if( *(buffer+1) == ' ' ){
	    sscanf(buffer, "v %f %f %f\n",
		    &verts[vct].x, &verts[vct].y, &verts[vct].z);
		verts[vct].x *= scale;
		verts[vct].y *= scale;
		verts[vct].z = verts[vct].z + z_trans_factor;
		/*
		 * Find the min's and max's
		 */
		if( verts[vct].x > global_x_max)
			global_x_max = verts[vct].x;
		if( verts[vct].x < global_x_min)
			global_x_min = verts[vct].x;
		if( verts[vct].y > global_y_max)
			global_y_max = verts[vct].y;
		if( verts[vct].y < global_y_min)
			global_y_min = verts[vct].y;
		if( verts[vct].z > global_z_max)
			global_z_max = verts[vct].z;
		if( verts[vct].z < global_z_min)
			global_z_min = verts[vct].z;
	    vct++;
	  } else if( *(buffer+1) == 'n' ){
	    sscanf(buffer, "vn %f %f %f\n",
		    &vertn[vnct].x, &vertn[vnct].y, &vertn[vnct].z);
	    vnct++;
	  } else if( *(buffer+1) == 't' ){
	    sscanf(buffer, "vt %f %f %f\n",
		    &vertt[vtct].x, &vertt[vtct].y, &vertt[vtct].z);
	    vtct++;
	  }
	    break;
	case 'f' :		/* a polygon face */
	    i=0;

	    bufptr = strchr( buffer, '\n'); /* clear out the newline (\n) */
	    if( *bufptr == '\0' ) break;
	    *bufptr = '\0';

	    bufptr = buffer;		/* look for first whitespace */
	    while( *bufptr != '\0' && !isspace(*bufptr)) bufptr++;
	    if( *bufptr == '\0' ) break;

	    /* look past spaces */
	    while( *bufptr != '\0' &&  isspace(*bufptr) ) bufptr++;
	    while(1){
		if( *bufptr == '\0' ) break;

		if( is_digit(*bufptr) )
		    value = atoi(bufptr);
		else {break;}

		if( value == 0 ){ break;}
		if( value < 0 )
		    value = vct + value + 1;
		if( value > vct+1 || value < 1 )
		    error_index("polygon","vertex",lcount);

		vert_indices[numEdges] = value-1;
		vt_indices[numEdges] = -1; /* init vt and vn indices */
		vn_indices[numEdges] = -1;
		i++; flag=0;
		numEdges++;
		/* look for next non-digit */
	        while( *bufptr != '\0' && is_digit(*bufptr)) bufptr++;
		if( *bufptr == '\0' ) break;

		/* check for a v//vn v/vt/vn */
		if( *bufptr == '/' ){
		   /* is it v/vt (case 1),  v//vn (case 2), v/vt/vn (case 3) */
		    bufptr++; 
		    flag = 1;
		    ptr = bufptr;
		    if( *bufptr == '/' ){
			flag = 2;  /* v//vn */
			bufptr++;
		    }
		    /* check for v/vt/vn */
		    while( *ptr != '\0' && flag != 3  && is_digit(*ptr) ) {
			if( *ptr == '/' ) flag = 3;
			ptr++;
		    }

		    switch( flag ){
			case 0:
			default:
			  break;
			case 1:		/* v/vt */
			    if( is_digit(*bufptr) )
				value   = atoi(bufptr);
			    else {break;}
			    if( value < 0 )
				value = vtct + value + 1;
			    if( value   > vtct+1 )
				error_index("polygon","texture",lcount);
			    vt_indices[numEdges-1] = value - 1;
			  break;
			case 3:		/* v/vt/vn */
			    if( is_digit(*bufptr) )
				value  = atoi(bufptr);
			    else {
				error_index( "polygon", "texture", lcount);
				break;
			    }

			    if( value < 0 )
				value = vtct + value + 1;
			    if( value   > vtct+1 || value   < 1 )
				error_index("polygon","texture",lcount);
			    vt_indices[numEdges-1] = value - 1;

			    if( is_digit(*ptr) )
				value   = atoi(ptr);
			    else {
				error_index( "polygon", "normal", lcount);
				break;
			    }
			    if( value < 0 )
				value = vnct + value + 1;

			    if( value   > vnct+1 || value   < 1 )
				error_index("polygon","normal",lcount);
			    vn_indices[numEdges-1] = value - 1;

			  break;
			case 2:		/* v//vn */
			    if( is_digit(*bufptr) )
				value   = atoi(bufptr);
			    else {
				error_index( "polygon", "normal", lcount);
				break;
			    }
			    if( value < 0 )
				value = vnct + value + 1;
			    if( value   > vnct+1 )
				error_index("polygon","normal",lcount);
			    vn_indices[numEdges-1] = value - 1;
			  break;
		     } /* end switch */
		    /* look forward to spaces */
	            while( *bufptr != '\0' && !isspace(*bufptr)) bufptr++;
		}
		/* look past spaces */
	        while( *bufptr != '\0' &&  isspace(*bufptr)) bufptr++;
		if( *bufptr == '\0' ) break;
	    }
	    facet_Count[poly_cnt] = i;
	  if( flip_flag )	/* swap indices */
		for(j= numEdges-facet_Count[i], itmp= numEdges-1; 
		    j<(numEdges-facet_Count[i])/2; j++, itmp--){
		    value = vert_indices[j];
		    vert_indices[j] = vert_indices[itmp];
		    vert_indices[itmp] = value;
	        }
	    if( flag == 2 || flag == 3 ){
		norm_Count[poly_cnt]  = i;
		/* printf("setting normal count to %d\n",i); */
		}
	   poly_cnt++;
	  break;
#endif
	case 's' :		/* a surf */

	    break;
	}
    }

    printf("%s contains %d vertices, %d polys, %d edges\n\n", 
		objname2, vct, poly_cnt, numEdges );
	fclose(fp2);

        ctr->x = global_x_min + (global_x_max - global_x_min) / 2.0;
        ctr->y = global_y_min + (global_y_max - global_y_min) / 2.0;
        ctr->z = global_z_min + (global_z_max - global_z_min) / 2.0;

#ifdef PRINT_MAX_MIN
printf(" center at %f, %f, %f\n",ctr->x, ctr->y, ctr->x);
printf(" min:max x %f, %f, y %f, %f z %f, %f\n",
	global_x_min, global_x_max, global_y_min, global_y_max,
	global_z_min, global_z_max);
#endif

}

error_index( type, str, lcount)
char *type, *str;
int  lcount;
{
    printf("%s %s index value is out of range at line %d\n",type,str,lcount);
    exit(-1);
}

int
is_digit( c )
int c;
{
    if( isdigit(c) || c == (int) '-' )
	return 1;
    else
	return 0;
}
